# -*- rpm-spec -*-

Name: libdb3
Version: 3.3.11
Release: alt9
%define _sover	%(echo %version |cut -d. -f1,2)
%define srcname db-%version

Summary: Berkeley database library
License: GPL
Group: System/Libraries
Url: http://www.sleepycat.com/
Packager: Berkeley DB Development Team <db@packages.altlinux.org>

Source: http://www.sleepycat.com/update/%version/%srcname.tar.bz2
Patch1: db-3.3.11-Makefile.patch
Patch2: db-3.1.17-compile.patch
Patch3: db-3.3.11-db_185.patch
Patch5: db-3.3.11-noticecall.patch
Patch6: db-3.3.11-ham_dirty_meta.patch
Patch7: db-3.3.11-db_chroot_prefix.patch

Provides: db3 = %version
Obsoletes: db3
Conflicts: glibc <= 2.1.3

BuildPreReq: coreutils, tcl-devel >= 8.3.4-alt8

# Automatically added by buildreq on Wed Sep 19 2001
BuildRequires: libdb1-devel gcc-c++ libstdc++-devel tcl-devel

%package -n db3-utils
Summary: Command line tools for managing Berkeley DB databases
Group: Databases
Requires: %name = %version-%release
Conflicts: db4-utils

%package devel
Summary: Development environment for Berkeley database library
Group: Development/C
Requires: %name = %version-%release, db3-utils = %version-%release
Provides: db3-devel = %version-%release
Obsoletes: db3-devel
Conflicts: libdb4-devel

%package devel-static
Summary: Static version of Berkeley database library
Group: Development/C
Requires: %name-devel = %version-%release
Provides: db3-devel-static = %version-%release
Obsoletes: db3-devel-static
Conflicts: libdb4-devel-static

%package -n %{name}_tcl
Summary: Tcl Development environment for Berkeley database library
Group: Development/Tcl
Requires: %name = %version-%release
Conflicts: libdb4_tcl

%package -n %{name}_tcl-devel
Summary: Tcl Development environment for Berkeley database library
Group: Development/C
Requires: %name-devel = %version-%release
Requires: %{name}_tcl = %version-%release
Conflicts: libdb4_tcl-devel

%package -n %{name}_tcl-devel-static
Summary: Tcl Development environment for Berkeley database library
Group: Development/C
Requires: %name-devel-static = %version-%release
Requires: %{name}_tcl-devel = %version-%release
Conflicts: libdb4_tcl-devel-static

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB is used by many applications, including Python and Perl, so this
should be installed on all systems.

%description -n db3-utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains command line tools for managing Berkeley DB databases.

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains the header files, libraries, and documentation for
building programs which use Berkeley DB.

%description devel-static
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains static libraries for building statically linked programs
which use Berkeley DB.

%description -n %{name}_tcl
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains Tcl API library

%description -n %{name}_tcl-devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains libraries for building programs using Tcl API

%description -n %{name}_tcl-devel-static
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains static libraries for Tcl API

%prep
%setup -q -n %srcname
chmod -R u+w .
%patch1 -p1
%patch2 -p1
%patch3 -p1
#%patch5 -p1
%patch6 -p1
%patch7 -p1

#pushd dist
#	./s_config
#popd

%build
%define _configure_script ../dist/configure

pushd build_unix
	# XXX --enable-java (missing include files)
	# XXX --enable-debug_{r,w}op should be disabled for production.
	%configure \
		--enable-compat185 \
		--enable-cxx \
		--enable-diagnostic \
		--enable-dump185 \
		--enable-rpc \
		--enable-tcl \
		--with-tcl=%_libdir
		# --enable-posixmutexes --enable-test --enable-debug --enable-debug_rop --enable-debug_wop
	# SMP-incompatible
	%__make
popd

rm -f examples_*/tags

%install
mkdir -p $RPM_BUILD_ROOT{/lib,%_libdir,%_tcllibdir,%_tcldatadir/Db_tcl,%_includedir/db3}

%makeinstall -C build_unix
mkdir -p $RPM_BUILD_ROOT%_docdir/%name-%version
install -p -m644 README LICENSE $RPM_BUILD_ROOT%_docdir/%name-%version/
cp -pRL docs/* examples_* $RPM_BUILD_ROOT%_docdir/%name-%version/

%define _libdb_a	libdb-%_sover.a
%define _libdb_so	libdb-%_sover.so

pushd $RPM_BUILD_ROOT
	mv .%_libdir/libdb-*.so lib
	ln -snf ../../lib/%_libdb_so .%_libdir/libdb.so

	ln -s %_libdb_a .%_libdir/libdb.a

	mv .%_libdir/libdb_tcl* .%_tcllibdir

	mv .%_includedir/*.h .%_includedir/db3
	ln -s db3/db.h .%_includedir/db.h
	#for F in .%prefix/bin/db_*; do
	#	mv "$F" "${F/db_/db3_}"
	#done
popd

# XXX libdb-%_sover.so is in /lib; teach libtool as well.
#ln -s ..%_libdir/%_libdb_a $RPM_BUILD_ROOT/lib/
ln -s ../../lib/%_libdb_so $RPM_BUILD_ROOT%_libdir/

%tea_makeindex -f libdb_tcl-%_sover.so -C $RPM_BUILD_ROOT%_tcldatadir/Db_tcl

find $RPM_BUILD_ROOT%_libdir -maxdepth 1 -name 'libdb*-%_sover.so' |
	sed -e "s|$RPM_BUILD_ROOT||g" >shared.list

find $RPM_BUILD_ROOT%_libdir -maxdepth 1 -not -type d -not -name 'libdb*-%_sover.so' -not -name 'lib*.a' -not -name '*.la' |
	sed -e "s|$RPM_BUILD_ROOT||g" >devel.list

%set_strip_method executable shared

%post -p %post_ldconfig
%postun -p %postun_ldconfig

%files -f shared.list
/lib/*.so
%_tcldatadir/Db_tcl
%dir %_docdir/%name-%version
%doc %_docdir/%name-%version/[A-Z]*

%files -n db3-utils
%_bindir/*

%files devel -f devel.list
%_includedir/*
%dir %_docdir/%name-%version
%doc %_docdir/%name-%version/[a-z]*

%files devel-static
%_libdir/*.a
%_tcllibdir/*.a

%files -n %{name}_tcl
%_tcllibdir/*_tcl-[0-9].[0-9].so
%_tcldatadir/Db_tcl

%files -n %{name}_tcl-devel
%_tcllibdir/*_tcl.so
%_tcllibdir/*_tcl-[0-9].so

%files -n %{name}_tcl-devel-static
%_tcllibdir/*_tcl*.a

%changelog
* Thu Nov 27 2003 Dmitry V. Levin <ldv@altlinux.org> 3.3.11-alt9
- Do not package .la files.
- Temporarily removed -v option from %%tea_makeindex call (Sergey Bolshakov).

* Sat Oct 12 2002 Dmitry V. Levin <ldv@altlinux.org> 3.3.11-alt8
- Fixed docs installation due to coreutils-4.5.2-alt1.

* Thu Oct 10 2002 Dmitry V. Levin <ldv@altlinux.org> 3.3.11-alt7
- Rebuilt in new environment.

* Fri Jun 14 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 3.3.11-alt6
- rebuilt in new env

* Wed Mar 13 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.3.11-alt5
- Fixed permissions on shared libraries (0000543).
- Conflicts: db4-utils, libdb4-devel, libdb4-devel-static.

* Mon Dec 10 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.3.11-alt4
- Fixed db_chroot_prefix hack (jbj).

* Wed Dec 05 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.3.11-alt3
- Added db_chroot_prefix hack.
- Added compatibility symlink to shared library.
- Dropped compatibility symlink to static library.

* Thu Oct 25 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.3.11-alt2
- Added ham_dirty_meta patch from Sleepycat.
- Added compatibility symlink to static library.

* Tue Sep 25 2001 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.3.11-alt1
- 3.3.11 release.
- Renamed library subpackages.
- Corrected interpackage requires.
- Moved static libraries to devel-static subpackage.
- Moved %_includedir/db_185.h symlink to libdb2-devel package.

* Fri Feb 02 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.9-ipl2mdk
- Added noticecall callback interface
  (by Alexander Bokovoy <ab@avilink.net>).

* Fri Feb 02 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.9-ipl1mdk
- 3.2.9 release.
- Enabled LFS support.
- Explicitly set strip methods.

* Mon Jan 15 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.3e-ipl2mdk
- Fixed db_185.h

* Thu Jan 04 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.3e-ipl1mdk
- New version for MaxSQL's transactions support.
- Disabled posixmutexes again.

* Sat Nov 11 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.17-ipl3mdk
- Rebuild with glibc-2.2 and for glibc-2.2.
- Docs cleanup.
- Enabled C++ api.
- Enabled posixmutexes.
- Fixed static/shared build.

* Sun Oct 01 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.17-ipl2mdk
- Rebuilt with glibc-2.1.94 & gcc-2.96.
- Defined _noVersionedDependencies.
- Automatically added BuildRequires.

* Mon Aug 21 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.17-ipl1mdk
- 3.1.17.

* Fri Aug 18 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.14-ipl1mdk
- RE and Fandra adaptions.

* Sun Jun 11 2000 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.1.14.
- create db3-utils sub-package to hide tcl dependency, enable tcl Yet Again.
- FHS packaging.

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- disable tcl Yet Again, base packages cannot depend on libtcl.so.

* Sat Jun  3 2000 Jeff Johnson <jbj@redhat.com>
- enable tcl, rebuild against tcltk 8.3.1 (w/o pthreads).

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- include /lib/libdb.so in the devel package

* Wed May 10 2000 Jeff Johnson <jbj@redhat.com>
- put in "System Environment/Libraries" per msw instructions.

* Tue May  9 2000 Jeff Johnson <jbj@redhat.com>
- install shared library in /lib, not /usr/lib.
- move API docs to db3-devel.

* Mon May  8 2000 Jeff Johnson <jbj@redhat.com>
- don't rename db_* to db3_*.

* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
